"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createExact = exports.createOptions = void 0;
const Parser_1 = __importDefault(require("../error/Parser"));
const orElseThrow = (t, isMatchingType, error) => {
    if (isMatchingType()) {
        return t();
    }
    throw error();
};
const createOptions = ({ t, expectedType, isMatchingType, }) => ({
    orElseGetNull: () => (!isMatchingType() ? null : t()),
    orElseGetUndefined: () => (!isMatchingType() ? undefined : t()),
    orElseGet: (a) => (!isMatchingType() ? a : t()),
    orElseLazyGet: (a) => (!isMatchingType() ? a() : t()),
    orElseThrowCustom: (message) => orElseThrow(t, isMatchingType, () => Parser_1.default.custom(message)),
    orElseThrowDefault: (name) => orElseThrow(t, isMatchingType, () => Parser_1.default.default({
        name,
        expectedType,
        value: t(),
    })),
});
exports.createOptions = createOptions;
const createExact = ({ t, e, expectedType, }) => createOptions({
    t: () => t,
    expectedType,
    isMatchingType: () => t === e,
});
exports.createExact = createExact;
//# sourceMappingURL=index.js.map