"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseAsReadonlyArray = exports.parseAsArray = void 0;
const parser_1 = require("../parser");
const util_1 = require("../util");
const util_2 = require("./util");
const getActualType = (u) => Array.isArray(u) ? 'array' : (0, util_1.getPossibleSelfDefinedType)(u);
const parseAsAnArray = (map, u, isImmutable) => (0, parser_1.createDataStructureParser)({
    expectedType: 'array',
    actualType: getActualType(u),
    t: () => (0, util_2.freeze)(() => u.map(map), isImmutable),
});
const orElseGetEmptyArray = (map, u, isImmutable) => !(0, util_1.isEqual)(getActualType(u), 'array')
    ? [].map(map)
    : (0, util_2.freeze)(() => u.map(map), isImmutable);
const parseAsArray = (u, map) => ({
    ...parseAsAnArray(map, u, false),
    orElseGetEmptyArray: () => orElseGetEmptyArray(map, u, false),
});
exports.parseAsArray = parseAsArray;
const parseAsReadonlyArray = (u, map) => ({
    ...parseAsAnArray(map, u, true),
    orElseGetReadonlyEmptyArray: () => orElseGetEmptyArray(map, u, true),
});
exports.parseAsReadonlyArray = parseAsReadonlyArray;
//# sourceMappingURL=array.js.map