"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseAsReadonlyObject = exports.parseAsObject = void 0;
const parser_1 = require("../parser");
const util_1 = require("../util");
const util_2 = require("./util");
const parseAsAnObject = (u, t, isImmutable) => {
    const actualType = (0, util_1.getPossibleSelfDefinedType)(u);
    return {
        ...(0, parser_1.createDataStructureParser)({
            actualType,
            expectedType: 'object',
            t: () => t(u),
        }),
        orElseGetEmptyObject: () => !(0, util_1.isEqual)('object', actualType)
            ? {}
            : (0, util_2.freeze)(() => t(u), isImmutable),
    };
};
const parseAsObject = (u, t) => parseAsAnObject(u, t, false);
exports.parseAsObject = parseAsObject;
const parseAsReadonlyObject = (u, t) => parseAsAnObject(u, t, true);
exports.parseAsReadonlyObject = parseAsReadonlyObject;
//# sourceMappingURL=object.js.map