"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPossibleSelfDefinedType = exports.isEqual = void 0;
const Parser_1 = __importDefault(require("../error/Parser"));
const isEqual = (c, d) => c === d;
exports.isEqual = isEqual;
const getPossibleSelfDefinedType = (u) => {
    const type = typeof u;
    switch (type) {
        case 'number':
        case 'boolean':
        case 'string':
        case 'object':
        case 'undefined':
            return type;
        default:
            throw Parser_1.default.custom(`typeof ${type} is not possible as JSON data`);
    }
};
exports.getPossibleSelfDefinedType = getPossibleSelfDefinedType;
//# sourceMappingURL=util.js.map