import { createDataStructureParser } from '../parser';
import { getPossibleSelfDefinedType, isEqual } from '../util';
import { freeze } from './util';
const parseAsAnObject = (u, t, isImmutable) => {
    const actualType = getPossibleSelfDefinedType(u);
    return {
        ...createDataStructureParser({
            actualType,
            expectedType: 'object',
            t: () => t(u),
        }),
        orElseGetEmptyObject: () => !isEqual('object', actualType)
            ? {}
            : freeze(() => t(u), isImmutable),
    };
};
const parseAsObject = (u, t) => parseAsAnObject(u, t, false);
const parseAsReadonlyObject = (u, t) => parseAsAnObject(u, t, true);
export { parseAsObject, parseAsReadonlyObject };
//# sourceMappingURL=object.js.map